import { ref } from 'vue'
import * as api from './api'
import XEUtils from 'xe-utils'

export const useFromData = (props) => {
  const formData = ref({
    name: '',
    rule: {
      type: props.data.templateType,
      campaignType: '',
      campaignAd: [],
      action: {},
      activeModel: '',
      // setTime: '',
      weekdays: [],
      conditions: [],
    }
  })

  function setFormData() {
    const { mode, data } = props
    if (mode === 'edit') {
      formData.value.name = data.templateName
      formData.value.rule.type = data.templateType
      formData.value.rule.campaignType = data.rule.campaignType
      formData.value.rule.campaignAd = data.rule.campaignAd
      if (data.rule.action) {
        formData.value.rule.action.state = data.rule.action.state
        formData.value.rule.action.setTime = data.rule.action.setTime
      }
      formData.value.rule.weekdays = data.rule.weekdays
      formData.value.rule.conditions = data.rule.conditions
    }
  }

  async function submitFormData() {
    const { mode, data } = props
    if (mode === 'add') {
      await api.createTemplate(formData.value)
    } else if (mode === 'edit') {
      await api.updateTemplate(data.templateId, formData.value)
    }
  }

  return { formData, setFormData, submitFormData }
}

